library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.NUMERIC_STD.ALL;


entity VGA is 
Generic (display_width : integer;								
		   display_height: integer);
Port (clk   : in std_logic;
	   hsync : out std_logic;
	   vsync : out std_logic;    
	   cx		: out unsigned(9 downto 0):= (others => '0');
	   cy		: out unsigned(9 downto 0):= (others => '0');
	   en    : out std_logic := '0');			  	  
end VGA;		
	  

architecture RTL of VGA is

	signal hst: unsigned(10 downto 0) := (others => '0');
	signal vst: unsigned(9 downto 0) := (others => '0');										
	signal H  : integer := 1040;
	signal Hp : integer := 800;
	signal Hf : integer := 856;
	signal Hs : integer := 120;							
	signal V  : integer := 666;
	signal Vp : integer := 600;
	signal Vf : integer := 637;
	signal Vs : integer := 6;
	signal cakaj: unsigned (13 downto 0) := (others => '0');		--Uporabno le za simulacijo s testno strukturo
	
begin




---- ------------Uporabno le za simulacijo s testno strukturo------------------
---- Hp <= display_width * 8;
---- Hf <= display_width * 8 + 56;
---- H  <= display_width * 8 + 240;
---- Vp <= display_height * 8;
---- Vf <= display_height * 8 + 37;
---- V  <= display_height * 8 + 66;
---- 
----
--process(clk)
--begin
--	if rising_edge(clk) then
--		if cakaj = (cakaj'range => '1')	then
--		else
--			cakaj <= cakaj+1;					
--		end if; 
--	end if;
--end process;
---- ---------------------------------------------------------------------------

process(clk)
begin
	if rising_edge(clk) then																
--		if cakaj >= (display_width * display_height - 2)	then		--Uporabno le za simulacijo s testno strukturo															
			if hst < H-1 then   	
				hst <= hst + 1;
			else
				hst <= (others => '0');
				if vst < V-1 then  
					vst <= vst + 1;
				else
					vst <= (others => '0');
				end if;
			end if;
--		end if;		--Uporabno le za simulacijo s testno strukturo
	end if;
end process;


 hsync <= '1' when hst >= Hf and hst < Hf + Hs
 else '0';
 vsync <= '1' when vst >= Vf and vst < Vf + Vs else '0';
   
 cx <= hst(9 downto 0); 
 cy <= vst;

		
process(clk)
begin
	if rising_edge(clk) then
		if hst >= Hp or vst >= Vp then
			en <= '0';
		else 
			en <= '1';
		end if;
	end if;
end process;
	

end RTL;
